Bug 83700 - UI Window: LibreOffice should use macOS design language and components for drawing window frame
Summary: UI Window: LibreOffice should use macOS design language and components for dr...
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other Mac OS X (All)
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: BSA
Keywords:
: 98228 (view as bug list)
Depends on:
Blocks: MacOS-Wishlist
  Show dependency treegraph
 
Reported: 2014-09-10 04:42 UTC by retired
Modified: 2019-03-28 21:20 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
TextEdit screenshot (5.73 MB, image/png)
2018-05-17 16:11 UTC, Tor Lillqvist
Details
Pages screenshot (8.79 MB, image/png)
2018-05-17 16:15 UTC, Tor Lillqvist
Details
Proposal: move the quickactions to the application title bar (minor) (606.58 KB, image/png)
2019-03-28 21:09 UTC, Maarten Brouwers
Details
Proposal: move the quickactions to the application title bar (less minor) (590.61 KB, image/png)
2019-03-28 21:20 UTC, Maarten Brouwers
Details

Note You need to log in before you can comment on or make changes to this bug.
Description retired 2014-09-10 04:42:03 UTC
Problem description: LO has a separate title bar making it look extraterrestrial on OSX

Steps to reproduce:
1. open LO
2. Look at top menu bar / title bar

Current behavior: separated title bar

Expected behavior: merged title bar, as is standard on OSX
Operating System: Mac OS X
Version: 4.1.0.4 release
Comment 1 Matthew Francis 2014-09-10 05:48:34 UTC
Confirmed. Setting to:
-> NEW
-> Enhancement
(Could set Version to "Inherited from OOo" as it's always been that way, but as it's more of an enhancement than a bug I'm not sure if that's helpful)

This would/should go together nicely with the support for the "Theming mechanism formely known as Persona" which LibreOffice already has. That is to say, when a theme is active, it should spread seamlessly into the title bar in the same way that it does in Firefox.
Comment 2 Iandol 2015-04-29 18:10:29 UTC
Hi, I think bug 69358 is already dealing with the title bar (normally titlebar and toolbar are combined on OS X and that is IIUC the intent of that bug), this should be set as a dup of that.

*** This bug has been marked as a duplicate of bug 69358 ***
Comment 3 Jan Holesovsky 2015-11-27 14:28:03 UTC
This should not be a duplicate, but a follow-up bug actually, no point in sorting everything out in one bugreport...

This is a known limitation, and it is quite hard to make the look so that the gradient spans over the entire top of the application.  Not impossible - but hard :-)

Needs somebody with a Mac to work on this; unfortunately I don't have one...
Comment 4 Alex Thurgood 2016-03-14 10:11:05 UTC
*** Bug 98228 has been marked as a duplicate of this bug. ***
Comment 5 Tor Lillqvist 2018-05-17 16:11:50 UTC
Created attachment 142165 [details]
TextEdit screenshot

Do you mean that the colour of the LibreOffice window title bars is dark? Is that what annoys you? Or what? Compare to TextEdit in this screenshot.
Comment 6 Tor Lillqvist 2018-05-17 16:15:37 UTC
Created attachment 142166 [details]
Pages screenshot

But sure, ideally it should look as much as possible like Pages, I guess. But is this really of "high" importance?
Comment 7 Tor Lillqvist 2018-05-24 13:02:15 UTC
@Matthew: No, we should not do any non-system theming stuff. We should behave and look like proper macOS app do. Not like some other multi-platform open source application. This is my opinion.
Comment 8 Tor Lillqvist 2018-05-24 14:07:55 UTC
The title of this bug is somewhat weird. The title bar of a window is not necessarily even close to the menu bar of the desktop. How could they be merged?  The window can be moved around and resized freely, and the title bar stays with the window. The menu bar is always at the top of the desktop.

Did the initial reporter mean that the title bar of a LO window and its contents, especially the area with LO tools etc right below the title bar, should be merged visually? That would make more sense. But note that native macOS apps that look like that use the system API for "toolbars" presumably. LO does not. So it is not trivial.

Anyway, setting to NEEDINFO in the (vain?) hope that the bug reporter would tell what they actually mean.
Comment 9 Tor Lillqvist 2018-05-24 14:08:59 UTC
Also adjusting importance to medium.
Comment 10 Matthew Francis 2018-05-25 05:04:36 UTC
@Tor
Respectfully, I think we're more in agreement than disagreement. I agree that LO should indeed look like an application that belongs on MacOS when on MacOS - not a purely "neutral cross platform" app.

The problem is it currently doesn't entirely look like it belongs. In most modern MacOS apps, the very top of the window is visually unified with what is immediately beneath, be it tabs, toolbars, buttons, search boxes or whatever else. However, LO windows still have a clearly delineated title bar, complete with mostly unused space except for window buttons and centred title text, and a sharp border at the bottom of the title bar like all apps used to have in the old days.

My point in addition to this in comment#1 meant that, if the visuals of the title bar are in fact updated to look like a modern MacOS app, the only viable and indeed reasonable thing to then do with the "Persona/Firefox" theming mechanism (which LO still supports natively, even though it may not be much used - it is in Options - LibreOffice - Personalisation - Own Theme) is for whatever background image it specifies to spread fully across the "area formerly known as the title bar", including the topmost part of the window - I had no other meaning than that in terms of cross-platform UI. Either that, or not to support it at all any longer, which I think would be a shame.

Setting this back to NEW as I believe this should sufficiently clarify the meaning of the bug - but I will also butt out at this point
Comment 11 Tor Lillqvist 2018-05-25 05:40:23 UTC
So is this bug then about making the title bar blend into the rest of the window, or makining the Firefox theme thing (that I have never, ever, heard anybody else mention, at least not for the Mac) spread into the title bar? Two entirely different things. And as the initial reporter calls himself "retired", I guess we will never know his/her opinion. Matthew, please file a new bug about the Firefox thing. This bug should be about what the initial bug reporter intended.
Comment 12 Matthew Francis 2018-05-25 06:52:00 UTC
I don't think there's another actual bug to be reported. Theming works as specified, at present, within the confines of how title bars are implemented on MacOS.

The entire mention of it was intended to note that anyone who actually works on this bug (as reported, the less than native look of the title bar) should consider the implications for theming. Apologies if that was not clear.
Comment 13 Emir Sarı (away) 2018-05-30 11:49:40 UTC
This requires a near-total rewrite of whole Libreoffice macOS UI code, no? I wonder how much would it cost if to crowd-source this.

Possible (UX-feasible) options:

1. Ditch LO toolbars, I mean, like purge them, delete them, destroy them with quantum torpedoes, transfer most formatting functions into sidebar, implement a proper macOS head-bar (is it OK to name it like this?) with standard functions like Open, Save etc. Also standard menus are not in a bad state now. 

or

2. Imitate Pages, distribute formatting commands into sidebar and headbar (even more labour-demanding than 1 I guess)
3. Imitate Office, go for the NotebookBar with custom theming, hide the title bar with it, like most Windows applications do (not favourable)
Comment 14 Tor Lillqvist 2018-05-30 11:55:41 UTC
Could somebody please edit the title of this bug to make sense? To men "top menu bar" is the thing at the top of the whole desktop, with the menu of the application that has focus. It obviously can't be "merged" into the title bar of an application window. Please change "top menu bar" to "inside of application window" or something, what sounds correct to you.
Comment 15 Emir Sarı (away) 2018-05-30 12:16:03 UTC
Got the correct term, window frame (https://developer.apple.com/macos/human-interface-guidelines/windows-and-views/window-anatomy/).

And I hope title is better now, hence what we want is more nativity to macOS at the end.
Comment 16 Sierk Bornemann 2018-05-31 12:36:00 UTC
(In reply to Emir Sarı (away) from comment #13)
> This requires a near-total rewrite of whole Libreoffice macOS UI code, no? I
> wonder how much would it cost if to crowd-source this.

Idea/Proposal:

If so extensive, too extensive for one developer to fix alone and in between – maybe worth to be a topic for the next GSoC (GSoC 2018 just seems to be over)?

Document Foundation’s wiki: LibreOffice Google Summer of Code
https://wiki.documentfoundation.org/Development/GSoC

Document Foundation’s wiki: GSoC Ideas
https://wiki.documentfoundation.org/Development/GSoC/Ideas

Document Foundation’s wiki: Development/GSoC/2018
https://wiki.documentfoundation.org/Development/GSoC/2018


Maybe worth to think about to fix also several other Mac related bugs on the (meanwhile long) list of meta-bug #42082 (MacOS-Wishlist) in a bunch of one or two or three concerted actions in the context of such an event and with higher priority and higher available developer ressources to get rid of them once and for all instead of leaving them unfixed for years (also because of lacking developer ressources to concrete fix them, which maybe could be addressed within GSoC or similar)?

What about this idea?
Comment 17 Maarten Brouwers 2019-03-28 21:09:40 UTC
Created attachment 150381 [details]
Proposal: move the quickactions to the application title bar (minor)

Selfishly addressing: #124407, but I believe LibreOffice.org is reasonably close to getting there already. With a generic UI kit you won't get 100% native experiences. Firefox, Chrome, Spotify, even pricewinning apps like Things and iA writer, all took a different path and while not in line with mac OS guidelines they don't look ugly. Above is actually not that far away from default mac OS apps like the config tool for Audio that is shipped as a default config screen with macOS. While I agree that LibreOffice.org should look more like TextEdit and Pages I'm not sure whether LibreOffice.org would ever get there. Maybe making even bolder departures from the default GUI (like the earlier mentioned apps) have made is even better.
Comment 18 Maarten Brouwers 2019-03-28 21:20:11 UTC
Created attachment 150383 [details]
Proposal: move the quickactions to the application title bar (less minor)

Removing lines; less macOS style; but cleaner overall which I believe is typically appreciated / better accepted by the macOS audience.

As written in my previous comment, award winning apps make these kind of departures. Things, iA Writer, Pixelmator...

One might even drop the default 'tab' control and go for a more custom control. Will I be banned for linking to a screenshot of Office for macOS? https://itunes.apple.com/us/app/microsoft-word/id462054704 (zoom in; the images have quite a high resolution). It's not hard to do a better job than MS.